import { InferDefaults, Row } from '../../types';
export type BodyProps = {
    loading: boolean;
    bodyRows: Row[];
    itemValue: string;
    columnsLength: number;
    selected: Row[] | null;
};
export declare const bodyPropDefaults: InferDefaults<BodyProps>;
export type BodyEmits = {
    (event: 'update:selected', value: Row[]): void;
};
