export type OptionValue = string | number | boolean | object | symbol;
export interface Option {
    content: OptionValue;
    label: string;
}
export type DropdownProps = {
    options: Option[];
    modelValue?: string | number;
    label?: string;
    defaultValue?: Option;
};
export declare const dropdownPropsDefaults: {
    options: () => never[];
    modelValue: string;
    label: string;
};
export type DropdownEmits = {
    (event: 'update:modelValue', value: OptionValue): void;
};
