import type { ColumnHeader, FlattenObject, NativeType } from '../types';
export declare function getBodyRows<TData>(rows: TData[], headers: ColumnHeader[]): FlattenObject<TData>[];
export declare function paginateRows<TData>(rows: TData[], start?: number, end?: number): TData[];
export declare function nestedObjectTransformer(obj: object): Record<string, any>;
export declare function deepValues(obj: any): any[];
export declare function isPrimitive(value: NativeType): boolean;
