import { openBlock as h, createElementBlock as g, createElementVNode as i, defineComponent as M, mergeDefaults as H, ref as V, computed as v, watchEffect as J, unref as c, toDisplayString as P, createVNode as $, createCommentVNode as T, withDirectives as E, normalizeClass as S, Fragment as L, renderList as B, vShow as X, nextTick as ee, mergeProps as te, isRef as I, vModelCheckbox as ne, createStaticVNode as oe, renderSlot as m, createTextVNode as G, toValue as O, useSlots as le, createSlots as x, withCtx as R, normalizeProps as j, guardReactiveProps as D } from "vue";
function se(t) {
  return t.replace(/_/g, " ").replace(/([a-z])([A-Z])/g, "$1 $2").replace(/(?:^|\s)\S/g, (n) => n.toUpperCase()).trim().replace(/\s\s+/g, " ");
}
function z(t) {
  let n = 1;
  return t.forEach((e) => {
    e.children && (n = Math.max(n, z(e.children) + 1));
  }), n;
}
function F(t) {
  let n = 0;
  return t.forEach((e) => {
    e.children ? n += F(e.children) : n++;
  }), n;
}
function Q(t, n, e = [], o = 0, s = 0, r = "") {
  return t.forEach((d) => {
    if (e[o] || (e[o] = []), d.children) {
      const { children: _, ...a } = d, l = F(_);
      e[o].push({
        ...a,
        colSpan: l,
        scope: "colgroup"
      }), Q(_, n, e, o + 1, s + 1, `${r}${d.key}.`);
    } else {
      const _ = n - s;
      e[o].push({
        ...d,
        key: d.key,
        fullKey: `${r}${d.key}`,
        label: d.label,
        rowSpan: _,
        scope: "col",
        sortable: Object.prototype.hasOwnProperty.call(d, "sortable") ? d.sortable : !0
      });
    }
  }), e;
}
function W(t, n = "", e = []) {
  return t.forEach((o) => {
    o.children ? W(o.children, `${n}${o.key}.`, e) : e.push(`${n}${o.key}`);
  }), e;
}
function Kt(t) {
  const n = z(t);
  return Q(t, n).reduce((s, r) => [...s, ...r], []);
}
function Y(t) {
  const n = [];
  for (const e in t) {
    const o = se(e), s = {
      key: e,
      label: o
    };
    if (typeof t[e] == "object" && t[e] !== null) {
      const r = Y(t[e]);
      r.length > 0 && (s.children = r);
    }
    n.push(s);
  }
  return n;
}
const ae = (t, n) => {
  const e = n.split(".");
  let o = t;
  for (let s = 0; s < e.length; s++)
    if (o[e[s]])
      o = o[e[s]];
    else
      return;
  return o;
};
function re(t, n) {
  return t.map((e) => W(n).map((o) => ({
    [o]: ae(e, o)
  })).reduce((o, s) => ({ ...o, ...s }), {}));
}
function ce(t, n = 0, e = t.length) {
  return t.slice(n, e);
}
function Z(t) {
  const n = {};
  for (const [e, o] of Object.entries(t))
    if (e.includes(".")) {
      const [s, r] = e.split(".");
      n[s] || (n[s] = {}), n[s][r] = o;
    } else
      n[e] = o;
  for (const [e, o] of Object.entries(n))
    typeof o == "object" && (n[e] = Z(o));
  return n;
}
function ie(t) {
  const n = [];
  for (const e in t)
    typeof t[e] == "object" ? n.push(...ie(t[e])) : n.push(t[e]);
  return n;
}
function ue(t) {
  return typeof t != "function" || typeof t != "object";
}
function Nt(t) {
  return (n, e, o) => t(n, e, o);
}
function de() {
  return {
    itemValue: "id",
    columnHeaders: () => [],
    data: () => [],
    perPage: 10,
    currentPage: 1,
    perPageOptions: () => [5, 10, 20, 30],
    loading: !1,
    selected: null,
    selectMode: "all",
    caption: "",
    summary: "",
    filterQuery: "",
    filterBy: void 0,
    filterMethod: (t, n, e) => t === "" || t === void 0 || e === void 0 || e.length === 0 ? !0 : e == null ? void 0 : e.some((s) => {
      const r = n[s];
      return ue(r) ? r == null ? void 0 : r.toString().toLowerCase().includes(t.toLowerCase()) : !1;
    })
  };
}
const pe = {
  options: () => [],
  modelValue: "",
  label: ""
}, U = (t, n) => {
  const e = t.__vccOpts || t;
  for (const [o, s] of n)
    e[o] = s;
  return e;
}, _e = {}, he = {
  xmlns: "http://www.w3.org/2000/svg",
  width: "1em",
  height: "1em",
  viewBox: "0 0 24 24"
}, ge = /* @__PURE__ */ i("path", {
  fill: "none",
  stroke: "currentColor",
  "stroke-linecap": "round",
  "stroke-linejoin": "round",
  "stroke-width": "1.5",
  d: "m19 9l-7 6l-7-6"
}, null, -1), be = [
  ge
];
function fe(t, n) {
  return h(), g("svg", he, be);
}
const me = /* @__PURE__ */ U(_e, [["render", fe]]), ve = { class: "table__dropdown-wrapper" }, we = ["aria-expanded"], ye = {
  class: "py-1",
  role: "none"
}, ke = ["onClick"], $e = /* @__PURE__ */ M({
  __name: "VueyeDropdown",
  props: H({
    options: {},
    modelValue: {},
    label: {},
    defaultValue: {}
  }, pe),
  emits: ["update:modelValue"],
  setup(t, { emit: n }) {
    const e = t, o = V(!1), s = V(-1), r = V(null), d = V(null), _ = V(!0), a = v(() => s.value === -1 ? e.options[0] : e.options[s.value]), l = `dropdown-label-${Math.random().toString(36).substring(2, 9)}`;
    async function u() {
      var w, p;
      if (o.value = !o.value, o.value) {
        await ee();
        const C = ((w = r.value) == null ? void 0 : w.getBoundingClientRect()) ?? { bottom: 0 }, k = ((p = d.value) == null ? void 0 : p.offsetHeight) ?? 200;
        _.value = window.innerHeight - (C == null ? void 0 : C.bottom) > k;
      }
    }
    function b(w) {
      s.value = w, o.value = !1, n("update:modelValue", a.value.content);
    }
    return J(() => {
      const w = e.options.findIndex((p) => p.content === e.modelValue);
      w !== -1 && (s.value = w), e.modelValue === void 0 && (s.value = -1);
    }), (w, p) => (h(), g("div", ve, [
      i("button", {
        type: "button",
        class: "table__dropdown-trigger",
        onClick: u,
        "aria-expanded": c(o),
        "aria-haspopup": !0,
        ref_key: "buttonRef",
        ref: r
      }, [
        i("span", null, P(c(a).label), 1),
        $(me)
      ], 8, we),
      c(o) ? (h(), g("div", {
        key: 0,
        class: "table__dropdown-overlay",
        onClick: u
      })) : T("", !0),
      E(i("div", {
        class: S(["table__dropdown-menu", { "table__dropdown-menu--top": !c(_) }]),
        role: "menu",
        "aria-orientation": "vertical",
        "aria-labelledby": l,
        ref_key: "dropdownMenuRef",
        ref: d
      }, [
        i("div", ye, [
          (h(!0), g(L, null, B(w.options, (C, k) => (h(), g("button", {
            key: k,
            class: S([{
              "table__dropdown-menu-item--selected ": k === c(s)
            }, "table__dropdown-menu-item"]),
            role: "menuitem",
            onClick: (K) => b(k)
          }, P(C.label), 11, ke))), 128))
        ])
      ], 2), [
        [X, c(o)]
      ])
    ]));
  }
}), Pe = {
  loading: !1,
  bodyRows: () => [],
  itemValue: "id",
  columnsLength: 0
}, Ce = ["id", "checked", "indeterminate"], Ve = ["for"], Se = /* @__PURE__ */ oe('<svg xmlns="http://www.w3.org/2000/svg" width="32" height="32" viewBox="0 0 24 24" aria-hidden="true"><g fill="none" stroke="currentColor" stroke-width="1.5"><path class="rounded-square" d="M2 12c0-4.714 0-7.071 1.464-8.536C4.93 2 7.286 2 12 2c4.714 0 7.071 0 8.535 1.464C22 4.93 22 7.286 22 12c0 4.714 0 7.071-1.465 8.535C19.072 22 16.714 22 12 22s-7.071 0-8.536-1.465C2 19.072 2 16.714 2 12Z"></path><path class="checkmark" stroke-linecap="round" stroke-linejoin="round" d="m8.5 12.5l2 2l5-5"></path><path class="indeterminate" stroke-linecap="round" stroke-linejoin="round" d="M6 12h12"></path></g></svg>', 1), q = /* @__PURE__ */ M({
  inheritAttrs: !1,
  __name: "VueyeCheckbox",
  props: {
    checked: Boolean,
    id: String,
    label: String,
    indeterminate: Boolean,
    modelValue: Boolean
  },
  emits: ["change", "update:modelValue"],
  setup(t, { emit: n }) {
    const e = t, o = V(e.modelValue), s = v({
      get() {
        return e.modelValue;
      },
      set(d) {
        n("update:modelValue", d);
      }
    }), r = (d) => {
      n("change", d);
    };
    return (d, _) => (h(), g("div", {
      class: S(["table__checkbox", { "table__checkbox--checked": o.value, "table__checkbox--indeterminate": t.indeterminate }])
    }, [
      E(i("input", te({
        id: t.id,
        type: "checkbox",
        checked: o.value,
        "onUpdate:modelValue": _[0] || (_[0] = (a) => I(s) ? s.value = a : null),
        indeterminate: t.indeterminate,
        onChange: r,
        "aria-labelledby": "checkboxLabel"
      }, d.$attrs), null, 16, Ce), [
        [ne, c(s)]
      ]),
      i("label", {
        for: t.id,
        id: "checkboxLabel"
      }, P(t.label), 9, Ve),
      Se
    ], 2));
  }
});
const Oe = { class: "table__body" }, Re = {
  key: 0,
  class: "table__row table__row--loading"
}, Be = ["colspan"], Me = {
  key: 1,
  class: "table__row table__row--empty"
}, je = ["colspan"], De = /* @__PURE__ */ i("div", { class: "text-center" }, "No data available", -1), Le = { class: "table__row" }, He = { class: "table__cell table_cell--checkbox" }, Ue = { class: "table__cell" }, Ke = /* @__PURE__ */ M({
  __name: "VueyeBody",
  props: H({
    loading: { type: Boolean },
    bodyRows: {},
    itemValue: {},
    columnsLength: {},
    selected: {}
  }, Pe),
  emits: ["update:selected"],
  setup(t, { emit: n }) {
    const e = t, o = v(() => Object.keys(e.bodyRows[0])), s = v(() => o.value.reduce(
      (a, l) => ({
        ...a,
        [l]: l.split(".").pop() ?? ""
      }),
      {}
    )), r = v(() => e.bodyRows.map((a) => ({
      flat: a,
      nest: Z(a)
    }))), d = v(() => r.value.map((a) => a.nest)), _ = v({
      get() {
        return e.selected;
      },
      set(a) {
        n("update:selected", a);
      }
    });
    return (a, l) => m(a.$slots, "body", { rows: a.bodyRows }, () => [
      i("tbody", Oe, [
        a.loading ? (h(), g("tr", Re, [
          i("td", {
            colspan: a.columnsLength,
            class: "table__cell table__cell--loading"
          }, [
            m(a.$slots, "loading", {}, () => [
              G(" Loading... ")
            ])
          ], 8, Be)
        ])) : a.bodyRows.length === 0 ? (h(), g("tr", Me, [
          i("td", {
            class: "table__cell",
            colspan: a.columnsLength
          }, [
            m(a.$slots, "empty", {}, () => [
              De
            ])
          ], 8, je)
        ])) : m(a.$slots, "rows", {
          key: 2,
          rows: c(d)
        }, () => [
          (h(!0), g(L, null, B(c(r), (u) => m(a.$slots, "row", {
            key: u[a.itemValue],
            row: u.nest
          }, () => [
            i("tr", Le, [
              a.selected ? m(a.$slots, "checkbox", {
                key: 0,
                row: u.nest
              }, () => [
                i("td", He, [
                  $(q, {
                    modelValue: c(_),
                    "onUpdate:modelValue": l[0] || (l[0] = (b) => I(_) ? _.value = b : null),
                    value: u.nest,
                    "aria-label": "Select row"
                  }, null, 8, ["modelValue", "value"])
                ])
              ]) : T("", !0),
              (h(!0), g(L, null, B(c(o), (b) => m(a.$slots, `itemCell.${b}`, {
                key: `${u[a.itemValue]}.${b}`,
                itemCell: u.nest
              }, () => [
                i("td", Ue, [
                  m(a.$slots, `itemCellContent.${c(s)[b]}`, {
                    itemCellContent: u.nest
                  }, () => [
                    G(P(u.flat[b]), 1)
                  ])
                ])
              ])), 128))
            ])
          ])), 128))
        ])
      ])
    ]);
  }
}), Ne = {
  columnHeaders: () => [],
  selectable: !1,
  select: "none"
}, Ie = {
  xmlns: "http://www.w3.org/2000/svg",
  width: "1em",
  height: "1em",
  viewBox: "0 0 16 16"
}, Ae = ["opacity"], Te = ["opacity"], Ee = /* @__PURE__ */ M({
  __name: "ArrowUpDownIcon",
  props: {
    down: Boolean
  },
  setup(t) {
    const n = t, e = v(() => ({
      up: n.down ? 0.5 : 1,
      down: n.down ? 1 : 0.5
    }));
    return (o, s) => (h(), g("svg", Ie, [
      i("path", {
        opacity: c(e).up,
        fill: "currentColor",
        fillRule: "evenodd",
        d: "M2.22 5.53a.75.75 0 0 1 0-1.06l2.25-2.25a.75.75 0 0 1 1.06 0l2.25 2.25a.75.75 0 0 1-1.06 1.06l-.97-.97v5.69a.75.75 0 0 1-1.5 0V4.56l-.97.97a.75.75 0 0 1-1.06 0",
        clipRule: "evenodd"
      }, null, 8, Ae),
      i("path", {
        opacity: c(e).down,
        fill: "currentColor",
        fillRule: "evenodd",
        d: "M13.78 10.47a.75.75 0 0 1 0 1.06l-2.25 2.25a.75.75 0 0 1-1.06 0l-2.25-2.25a.75.75 0 1 1 1.06-1.06l.97.97V5.75a.75.75 0 0 1 1.5 0v5.69l.97-.97a.75.75 0 0 1 1.06 0",
        clipRule: "evenodd"
      }, null, 8, Te)
    ]));
  }
}), ze = { class: "table__head" }, Fe = ["colspan", "rowspan", "scope"], Qe = ["onClick"], We = /* @__PURE__ */ M({
  __name: "VueyeHead",
  props: H({
    columnHeaders: {},
    selectable: { type: Boolean },
    select: {}
  }, Ne),
  emits: ["update:select", "sort"],
  setup(t, { emit: n }) {
    const e = t, o = V(""), s = V(!1), r = (l) => {
      l.sortable && l.scope === "col" && (o.value === l.fullKey ? s.value = !s.value : (o.value = l.fullKey ?? "", s.value = !1), n("sort", { key: o.value, desc: s.value }));
    }, d = v(() => e.selectable ? [
      [
        {
          key: "checkbox",
          label: "",
          className: "checkbox",
          colSpan: 1,
          rowSpan: e.columnHeaders.length,
          scope: "col"
        },
        ...e.columnHeaders[0]
      ],
      ...e.columnHeaders.slice(1)
    ] : e.columnHeaders), _ = v({
      get() {
        return e.select;
      },
      set(l) {
        n("update:select", l);
      }
    }), a = (l) => {
      l.target.checked ? _.value = "all" : _.value = "none";
    };
    return (l, u) => m(l.$slots, "headers", { headers: l.columnHeaders }, () => [
      i("thead", ze, [
        (h(!0), g(L, null, B(c(d), (b, w) => (h(), g("tr", {
          class: "table__row table__row",
          key: w
        }, [
          (h(!0), g(L, null, B(b, (p) => m(l.$slots, `headerCell.${p.key}`, {
            key: p.key,
            headerItem: p
          }, () => [
            i("th", {
              colspan: p.colSpan,
              rowspan: p.rowSpan,
              scope: p.scope,
              class: S(["table__cell table__cell--head", p.className])
            }, [
              p.key === "checkbox" && l.selectable ? m(l.$slots, "checkbox", { key: 0 }, () => [
                $(q, {
                  indeterminate: c(_) === "indeterminate",
                  type: "checkbox",
                  checked: c(_) === "all",
                  onChange: a,
                  "aria-label": "select all rows",
                  class: "table__checkbox"
                }, null, 8, ["indeterminate", "checked"])
              ]) : m(l.$slots, `headerCellContent.${p.key}`, {
                key: 1,
                headerItem: p
              }, () => [
                p.scope === "col" ? (h(), g("button", {
                  key: 0,
                  onClick: (C) => r(p),
                  class: "table__sort-button"
                }, [
                  i("span", {
                    class: S(["table__label table__label--head", p.labelClassName])
                  }, P(p.label), 3),
                  $(Ee, {
                    class: S([{ "table__sort-icon--show": c(o) === p.key }, "table__sort-icon"]),
                    down: c(s)
                  }, null, 8, ["class", "down"])
                ], 8, Qe)) : (h(), g("span", {
                  key: 1,
                  class: S(["table__label table__label--head", p.labelClassName])
                }, P(p.label), 3))
              ])
            ], 10, Fe)
          ])), 128))
        ]))), 128))
      ])
    ]);
  }
});
const Ze = {}, Ge = {
  xmlns: "http://www.w3.org/2000/svg",
  width: "1em",
  height: "1em",
  viewBox: "0 0 24 24"
}, xe = /* @__PURE__ */ i("path", {
  fill: "none",
  stroke: "currentColor",
  "stroke-linecap": "round",
  "stroke-linejoin": "round",
  "stroke-width": "1.5",
  d: "m9 5l6 7l-6 7"
}, null, -1), Je = [
  xe
];
function Xe(t, n) {
  return h(), g("svg", Ge, Je);
}
const Ye = /* @__PURE__ */ U(Ze, [["render", Xe]]), qe = {}, et = {
  xmlns: "http://www.w3.org/2000/svg",
  width: "1em",
  height: "1em",
  viewBox: "0 0 24 24"
}, tt = /* @__PURE__ */ i("path", {
  fill: "none",
  stroke: "currentColor",
  "stroke-linecap": "round",
  "stroke-linejoin": "round",
  "stroke-width": "1.5",
  d: "m15 5l-6 7l6 7"
}, null, -1), nt = [
  tt
];
function ot(t, n) {
  return h(), g("svg", et, nt);
}
const lt = /* @__PURE__ */ U(qe, [["render", ot]]), st = {}, at = {
  xmlns: "http://www.w3.org/2000/svg",
  width: "1em",
  height: "1em",
  viewBox: "0 0 24 24"
}, rt = /* @__PURE__ */ i("g", {
  fill: "none",
  stroke: "currentColor",
  "stroke-linecap": "round",
  "stroke-linejoin": "round",
  "stroke-width": "1.5"
}, [
  /* @__PURE__ */ i("path", { d: "m11 19l6-7l-6-7" }),
  /* @__PURE__ */ i("path", { d: "m7 19l6-7l-6-7" })
], -1), ct = [
  rt
];
function it(t, n) {
  return h(), g("svg", at, ct);
}
const ut = /* @__PURE__ */ U(st, [["render", it]]), dt = {}, pt = {
  xmlns: "http://www.w3.org/2000/svg",
  width: "1em",
  height: "1em",
  viewBox: "0 0 24 24"
}, _t = /* @__PURE__ */ i("g", {
  fill: "none",
  stroke: "currentColor",
  "stroke-linecap": "round",
  "stroke-linejoin": "round",
  "stroke-width": "1.5"
}, [
  /* @__PURE__ */ i("path", { d: "m13 19l-6-7l6-7" }),
  /* @__PURE__ */ i("path", { d: "m17 19l-6-7l6-7" })
], -1), ht = [
  _t
];
function gt(t, n) {
  return h(), g("svg", pt, ht);
}
const bt = /* @__PURE__ */ U(dt, [["render", gt]]), ft = {
  perPage: 10,
  currentPage: 1,
  total: 0,
  perPageOptions: () => [10, 20, 30, 40, 50]
}, mt = { class: "table__pagination-wrapper" }, vt = { class: "table__pagination-details" }, wt = { class: "table__pagination-btn-list" }, yt = ["disabled"], kt = ["disabled"], $t = ["onClick", "aria-label"], Pt = {
  key: 1,
  class: "table__pagination-btn table__btn"
}, Ct = ["disabled"], Vt = ["disabled"], St = /* @__PURE__ */ M({
  __name: "VueyePagination",
  props: H({
    perPage: {},
    currentPage: {},
    total: {},
    perPageOptions: {}
  }, ft),
  emits: ["update:currentPage", "update:perPage"],
  setup(t, { emit: n }) {
    const e = t, o = v(() => Math.ceil(e.total / e.perPage)), s = v(() => e.perPageOptions.map((l) => ({
      content: l,
      label: l.toString()
    }))), r = v(() => s.value.find((l) => l.content === e.perPage)), d = v(() => Array.from({ length: o.value }, (l, u) => u + 1).reduce(
      (l, u) => (u === 1 || u === e.total || u >= e.currentPage - 2 && u <= e.currentPage + 2 ? l.push(u) : (u === e.currentPage - 3 || u === e.currentPage + 3) && l.push("..."), l),
      []
    ));
    function _(l) {
      n("update:perPage", Number(l));
    }
    function a(l) {
      l >= 1 && l <= o.value && n("update:currentPage", l);
    }
    return (l, u) => (h(), g("div", mt, [
      $(c($e), {
        options: c(s),
        "default-value": c(r),
        label: "Per page",
        "onUpdate:modelValue": _
      }, null, 8, ["options", "default-value"]),
      i("span", vt, P((l.currentPage - 1) * l.perPage + 1) + " - " + P(l.currentPage * l.perPage > l.total ? l.total : l.currentPage * l.perPage) + " of " + P(l.total), 1),
      i("ul", wt, [
        i("li", null, [
          i("button", {
            class: "table__pagination-btn table__btn",
            onClick: u[0] || (u[0] = (b) => a(1)),
            disabled: l.currentPage === 1,
            "aria-label": "First page"
          }, [
            $(bt)
          ], 8, yt)
        ]),
        i("li", null, [
          i("button", {
            class: "table__pagination-btn table__btn",
            onClick: u[1] || (u[1] = (b) => a(e.currentPage - 1)),
            disabled: l.currentPage === 1,
            "aria-label": "Previous page"
          }, [
            $(lt)
          ], 8, kt)
        ]),
        (h(!0), g(L, null, B(c(d), (b) => (h(), g("li", { key: b }, [
          typeof b == "number" ? (h(), g("button", {
            key: 0,
            class: S(["table__pagination-btn table__btn", { "table__pagination-btn--current ": b === l.currentPage }]),
            onClick: (w) => a(b),
            "aria-label": "Go to page " + b
          }, P(b), 11, $t)) : (h(), g("span", Pt, "..."))
        ]))), 128)),
        i("li", null, [
          i("button", {
            class: "table__pagination-btn table__btn",
            onClick: u[2] || (u[2] = (b) => a(l.currentPage + 1)),
            disabled: l.currentPage === c(o),
            "aria-label": "Next page"
          }, [
            $(Ye)
          ], 8, Ct)
        ]),
        i("li", null, [
          i("button", {
            class: "table__pagination-btn table__btn",
            onClick: u[3] || (u[3] = (b) => a(l.total)),
            disabled: l.currentPage === c(o),
            "aria-label": "Last page"
          }, [
            $(ut)
          ], 8, Vt)
        ])
      ])
    ]));
  }
});
function It(t) {
  return {
    headerKeys: v(() => W(t.flat()))
  };
}
function Ot(t = {}, n) {
  const e = V({
    perPage: t.perPage || 10,
    currentPage: t.currentPage || 1
  });
  J(() => {
    e.value.perPage = t.perPage || 10, e.value.currentPage = t.currentPage || 1;
  });
  function o(r) {
    e.value.currentPage = r, n("update:currentPage", r);
  }
  function s(r) {
    e.value.perPage = r, n("update:perPage", r);
  }
  return {
    pagination: e,
    updateCurrentPage: o,
    updatePerPage: s
  };
}
function Rt(t, n, e) {
  const o = V(), s = V(!1);
  function r({ key: _, desc: a }) {
    o.value = _, s.value = a;
  }
  return {
    bodyRows: v(() => {
      const _ = O(e).perPage * (O(e).currentPage - 1), a = O(e).perPage * O(e).currentPage, l = re(O(t.data), O(n)), u = v(() => t.filterBy === void 0 || t.filterBy.length === 0 ? Object.keys(l[0]) : t.filterBy), b = l.filter((w) => {
        var p;
        return (p = t.filterMethod) == null ? void 0 : p.call(t, t.filterQuery, w, O(u));
      });
      return o.value && b.sort((w, p) => {
        if (!o.value)
          return 0;
        const C = w[o.value], k = p[o.value];
        return C < k ? s.value ? 1 : -1 : C > k ? s.value ? -1 : 1 : 0;
      }), ce(b, _, a);
    }),
    rowsCount: v(() => O(t.data).length),
    onSort: r
  };
}
function Bt(t) {
  const n = c(t) ?? [];
  return {
    headers: v(() => Q(n, z(n))),
    headersCount: F(n)
  };
}
function Mt(t, n, e) {
  const o = v({
    get() {
      var r, d, _;
      return t.selected === null || ((r = t.selected) == null ? void 0 : r.length) === 0 ? "none" : ((d = t.selected) == null ? void 0 : d.length) === t.data.length || t.selectMode === "page" && ((_ = t.selected) == null ? void 0 : _.length) === n.value.length ? "all" : "indeterminate";
    },
    set(r) {
      r === "all" ? t.selectMode === "page" ? s.value = n.value.map((d) => Z(d)) : s.value = t.data : r === "none" && (s.value = []);
    }
  }), s = v({
    get() {
      return t.selected;
    },
    set(r) {
      e("update:selected", r);
    }
  });
  return {
    selectAll: o,
    selected: s
  };
}
const jt = { class: "table__wrapper" }, Dt = {
  key: 0,
  class: "table__caption"
}, Lt = { class: "table__summary" }, At = /* @__PURE__ */ M({
  inheritAttrs: !1,
  __name: "VueyeTable",
  props: H({
    data: {},
    columnHeaders: {},
    itemValue: {},
    perPage: {},
    currentPage: {},
    perPageOptions: {},
    loading: { type: Boolean },
    selected: {},
    selectMode: {},
    caption: {},
    summary: {},
    filterQuery: {},
    filterBy: {},
    filterMethod: { type: Function }
  }, de()),
  emits: ["update:currentPage", "update:perPage", "update:loading", "update:selected"],
  setup(t, { emit: n }) {
    const e = t, o = v(
      () => e.columnHeaders.length === 0 ? Y(e.data[0]) : e.columnHeaders
    ), { headers: s, headersCount: r } = Bt(o), d = le(), _ = Object.keys(d).filter((f) => f.startsWith("headerCell")), a = Object.keys(d).filter((f) => f.startsWith("itemCell")), { pagination: l, updateCurrentPage: u, updatePerPage: b } = Ot(e, n), { bodyRows: w, rowsCount: p, onSort: C } = Rt(e, o, l), { selected: k, selectAll: K } = Mt(e, w, n);
    return (f, N) => (h(), g("div", jt, [
      i("table", {
        class: S(f.$attrs.class ?? "table")
      }, [
        m(f.$slots, "caption", {}, () => [
          f.caption ? (h(), g("caption", Dt, P(f.caption), 1)) : T("", !0)
        ]),
        $(c(We), {
          columnHeaders: c(s),
          selectable: f.selected !== null,
          select: c(K),
          "onUpdate:select": N[0] || (N[0] = (y) => I(K) ? K.value = y : null),
          onSort: c(C)
        }, x({
          headers: R((y) => [
            m(f.$slots, "headers", j(D(y)))
          ]),
          _: 2
        }, [
          B(c(_), (y) => ({
            name: y,
            fn: R((A) => [
              m(f.$slots, y, j(D(A)))
            ])
          }))
        ]), 1032, ["columnHeaders", "selectable", "select", "onSort"]),
        $(c(Ke), {
          selected: c(k),
          "onUpdate:selected": N[1] || (N[1] = (y) => I(k) ? k.value = y : null),
          bodyRows: c(w),
          loading: f.loading,
          itemValue: f.itemValue,
          "columns-length": c(r)
        }, x({
          checkbox: R((y) => [
            m(f.$slots, "checkbox", j(D(y)))
          ]),
          loading: R(() => [
            m(f.$slots, "loading")
          ]),
          empty: R(() => [
            m(f.$slots, "empty")
          ]),
          rows: R((y) => [
            m(f.$slots, "rows", j(D(y)))
          ]),
          row: R((y) => [
            m(f.$slots, "row", j(D(y)))
          ]),
          _: 2
        }, [
          B(c(a), (y) => ({
            name: y,
            fn: R((A) => [
              m(f.$slots, y, j(D(A)))
            ])
          }))
        ]), 1032, ["selected", "bodyRows", "loading", "itemValue", "columns-length"]),
        m(f.$slots, "summary", {}, () => [
          i("caption", Lt, P(f.summary), 1)
        ])
      ], 2),
      m(f.$slots, "pagination", {
        pagination: { ...c(l), perPageOptions: f.perPageOptions, total: c(p) }
      }, () => [
        E($(c(St), {
          perPage: c(l).perPage,
          currentPage: c(l).currentPage,
          perPageOptions: f.perPageOptions,
          total: c(p),
          "onUpdate:currentPage": c(u),
          "onUpdate:perPage": c(b),
          class: "table__pagination"
        }, null, 8, ["perPage", "currentPage", "perPageOptions", "total", "onUpdate:currentPage", "onUpdate:perPage"]), [
          [X, f.data.length > 0]
        ])
      ])
    ]));
  }
});
function Ht(t) {
  const n = [];
  for (const e of t) {
    const o = e.children ? Ht(e.children) : void 0;
    n.push({
      ...e,
      children: o
    });
  }
  return n;
}
export {
  At as VueyeTable,
  ie as deepValues,
  Kt as defineColumnHeaders,
  Nt as defineFilterMethod,
  Ht as defineTableColumnHeaders,
  z as depthCount,
  Q as flatHeadersToRows,
  Y as generateColumns,
  re as getBodyRows,
  W as getHeaderKeys,
  de as getVueyeTablePropDefaults,
  se as humanize,
  ue as isPrimitive,
  F as leafCount,
  Z as nestedObjectTransformer,
  ce as paginateRows,
  Rt as useBodyRows,
  It as useHeaderKeys,
  Bt as useHeaders,
  Ot as usePagination,
  Mt as useSelection
};
