import { VueyeTableEmits } from './api';
import type { ColumnHeader } from './types';
declare const _default: <TData extends Record<string, unknown> = Record<string, unknown>, TColumn extends ColumnHeader<TData> = ColumnHeader<TData>>(__VLS_props: {
    caption?: string | undefined;
    data: TData[];
    summary?: string | undefined;
    perPage?: number | undefined;
    currentPage?: number | undefined;
    perPageOptions?: number[] | undefined;
    columnHeaders?: TColumn[] | undefined;
    itemValue?: string | undefined;
    loading?: boolean | undefined;
    selected?: import("./types").Row[] | TData[] | null | undefined;
    selectMode?: "page" | "all" | undefined;
    filterQuery?: string | undefined;
    filterBy?: import("./types").FlattenKeys<TData, "">[] | undefined;
    filterMethod?: import("./api").FilterMethod<TData> | undefined;
    "onUpdate:selected"?: ((value: TData[]) => any) | undefined;
    "onUpdate:currentPage"?: ((value: number) => any) | undefined;
    "onUpdate:perPage"?: ((value: number) => any) | undefined;
    "onUpdate:loading"?: ((value: boolean) => any) | undefined;
} & import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, __VLS_ctx?: {
    attrs: any;
    slots: Readonly<import("./types").SlotHeaderCell<TData> & import("./types").SlotHeaderCellContent<TData> & {
        headers: (props: {
            headers: ColumnHeader<Record<string, unknown>>[][];
        }) => any;
        checkbox: () => any;
    } & import("./types").SlotRowItem<TData> & import("./types").SlotRowItemContent<TData> & {
        body: (props: {
            rows: TData[];
        }) => any;
        rows: (props: {
            rows: TData[];
        }) => any;
        row: (props: {
            row: TData;
        }) => any;
        checkbox: (props: {
            row: TData;
        }) => any;
    } & {
        caption: () => any;
        summary: () => any;
        loading: () => any;
        empty: () => any;
        pagination: (props: {
            pagination: import("./components").PaginationProps;
        }) => any;
    }>;
    emit: VueyeTableEmits<TData>;
} | undefined, __VLS_expose?: ((exposed: import('vue').ShallowUnwrapRef<{}>) => void) | undefined, __VLS_setup?: Promise<{
    props: {
        caption?: string | undefined;
        data: TData[];
        summary?: string | undefined;
        perPage?: number | undefined;
        currentPage?: number | undefined;
        perPageOptions?: number[] | undefined;
        columnHeaders?: TColumn[] | undefined;
        itemValue?: string | undefined;
        loading?: boolean | undefined;
        selected?: import("./types").Row[] | TData[] | null | undefined;
        selectMode?: "page" | "all" | undefined;
        filterQuery?: string | undefined;
        filterBy?: import("./types").FlattenKeys<TData, "">[] | undefined;
        filterMethod?: import("./api").FilterMethod<TData> | undefined;
        "onUpdate:selected"?: ((value: TData[]) => any) | undefined;
        "onUpdate:currentPage"?: ((value: number) => any) | undefined;
        "onUpdate:perPage"?: ((value: number) => any) | undefined;
        "onUpdate:loading"?: ((value: boolean) => any) | undefined;
    } & import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps;
    expose(exposed: import('vue').ShallowUnwrapRef<{}>): void;
    attrs: any;
    slots: Readonly<import("./types").SlotHeaderCell<TData> & import("./types").SlotHeaderCellContent<TData> & {
        headers: (props: {
            headers: ColumnHeader<Record<string, unknown>>[][];
        }) => any;
        checkbox: () => any;
    } & import("./types").SlotRowItem<TData> & import("./types").SlotRowItemContent<TData> & {
        body: (props: {
            rows: TData[];
        }) => any;
        rows: (props: {
            rows: TData[];
        }) => any;
        row: (props: {
            row: TData;
        }) => any;
        checkbox: (props: {
            row: TData;
        }) => any;
    } & {
        caption: () => any;
        summary: () => any;
        loading: () => any;
        empty: () => any;
        pagination: (props: {
            pagination: import("./components").PaginationProps;
        }) => any;
    }>;
    emit: VueyeTableEmits<TData>;
}>) => globalThis.VNode<import("vue").RendererNode, import("vue").RendererElement, {
    [key: string]: any;
}> & {
    __ctx?: {
        props: {
            caption?: string | undefined;
            data: TData[];
            summary?: string | undefined;
            perPage?: number | undefined;
            currentPage?: number | undefined;
            perPageOptions?: number[] | undefined;
            columnHeaders?: TColumn[] | undefined;
            itemValue?: string | undefined;
            loading?: boolean | undefined;
            selected?: import("./types").Row[] | TData[] | null | undefined;
            selectMode?: "page" | "all" | undefined;
            filterQuery?: string | undefined;
            filterBy?: import("./types").FlattenKeys<TData, "">[] | undefined;
            filterMethod?: import("./api").FilterMethod<TData> | undefined;
            "onUpdate:selected"?: ((value: TData[]) => any) | undefined;
            "onUpdate:currentPage"?: ((value: number) => any) | undefined;
            "onUpdate:perPage"?: ((value: number) => any) | undefined;
            "onUpdate:loading"?: ((value: boolean) => any) | undefined;
        } & import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps;
        expose(exposed: import('vue').ShallowUnwrapRef<{}>): void;
        attrs: any;
        slots: Readonly<import("./types").SlotHeaderCell<TData> & import("./types").SlotHeaderCellContent<TData> & {
            headers: (props: {
                headers: ColumnHeader<Record<string, unknown>>[][];
            }) => any;
            checkbox: () => any;
        } & import("./types").SlotRowItem<TData> & import("./types").SlotRowItemContent<TData> & {
            body: (props: {
                rows: TData[];
            }) => any;
            rows: (props: {
                rows: TData[];
            }) => any;
            row: (props: {
                row: TData;
            }) => any;
            checkbox: (props: {
                row: TData;
            }) => any;
        } & {
            caption: () => any;
            summary: () => any;
            loading: () => any;
            empty: () => any;
            pagination: (props: {
                pagination: import("./components").PaginationProps;
            }) => any;
        }>;
        emit: VueyeTableEmits<TData>;
    } | undefined;
};
export default _default;
type __VLS_Prettify<T> = {
    [K in keyof T]: T[K];
} & {};
