import { ColumnHeader, InferDefaults } from '../../types';
type SelectState = 'all' | 'indeterminate' | 'none';
export type HeadProps = {
    columnHeaders: ColumnHeader[][];
    selectable?: boolean;
    select?: SelectState;
};
export declare const headPropDefaults: InferDefaults<HeadProps>;
export type HeadEmits = {
    (event: 'update:select', value: SelectState): void;
    (event: 'sort', value: {
        key: any;
        desc: boolean;
    }): void;
};
export {};
