import { InferDefaults } from '../../types';
export interface PaginationProps {
    perPage: number;
    currentPage: number;
    total: number;
    perPageOptions: number[];
}
export declare const paginationPropsDefaults: InferDefaults<PaginationProps>;
export interface PaginationEmits {
    (event: 'update:currentPage', value: number): void;
    (event: 'update:perPage', value: number): void;
}
