import { PaginationEmits } from '../components';
export declare function usePagination(props: {
    perPage?: number | undefined;
    currentPage?: number | undefined;
} | undefined, emit: PaginationEmits): {
    pagination: globalThis.Ref<{
        perPage: number;
        currentPage: number;
    }>;
    updateCurrentPage: (page: number) => void;
    updatePerPage: (perPage: number) => void;
};
